Public Module Helpers

    Public Function GetRow(Of T As DataRow)(ByVal Current As Object) As T
        If Current Is Nothing Then Return Nothing
        Return DirectCast(DirectCast(Current, DataRowView).Row, T)
    End Function

    Public Function BindingSourceFind( _
            ByVal BindingSource As BindingSource, _
            ByVal PropertyName As String, _
            ByVal Key As Object) As Integer
        For BindingSourceFind = BindingSource.Count - 1 To 0 Step -1
            If DirectCast(BindingSource(BindingSourceFind), DataRowView)(PropertyName) _
                  .Equals(Key) Then Exit Function
        Next
    End Function

    ''' <summary> vor Zuweisung testen, ob neuer Wert nderung darstellt </summary>
    ''' <remarks>
    ''' ntzlich bei Zuweisungen an performance-intensive Properties (z.B. Control.Text), 
    ''' oder wenn auf nderungen reagiert werden mu.
    ''' Bei DataRows knnen Update-Probleme auftreten, wenn ein Feld mit seinem eigenen Wert 
    ''' berschrieben wird: Die Connection will eine nderung speichern, aber es ist nix gendert.
    ''' </remarks>
    Public Function AssignSave(Of T)(ByRef Dest As T, ByVal Src As T) As Boolean
        If Object.Equals(Dest, Src) Then Return False
        Dest = Src
        Return True
    End Function

    ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
    Public Sub Dbg(ByVal ParamArray Args As Object())
        Dim Args2(Args.Length * 2 - 1) As Object
        For i As Integer = 0 To Args.Length - 1
            Args2(i * 2) = Args(i)
            Args2(i * 2 + 1) = " "
        Next
        Debug.WriteLine(String.Concat(Args2))
    End Sub

End Module
